/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2014 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp.
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 27/Jan/2014
//***********************************************************************************************************

#include <stdio.h>
#include "W79E8213.h"
#include "Typedef.h"
#include "Define.h"

//-----------------------------------------------------------------------------------------------------------
#ifdef  TimerDivid4
            T0M = 1;
            T1M = 1;
#endif
#ifdef  TimerDivid12
            T0M = 0;
            T1M = 0;
#endif
//-----------------------------------------------------------------------------------------------------------
#ifdef  FOSC_110592                     // External Crystal = 11.0592MHz
    #define VALUE_10us    65536-9       // 9*12/11.0592 = 10 uS
    #define VALUE_1ms     65536-923     // 923*12/11.0592 = 1 mS
#endif
#ifdef  FOSC_184320                     // External Crystal = 18.432MHz
    #define VALUE_10us    65536-15      // 15*12/18.432 = 10 uS
    #define VALUE_1ms     65536-1536    // 1536*12/18.432 = 1 mS
#endif
#ifdef  FOSC_221184                     // External Crystal = 22.1184MHz
    #define VALUE_10us    65536-18      // 18*12/22.1184 = 10 uS
    #define VALUE_1ms     65536-1843    // 1843*12/22.1184 = 1 mS
#endif
#ifdef  FOSC_368640                     // External Crystal = 36.864MHz
    #define VALUE_10us    65536-31      // 31*12/36.864 = 10 uS
    #define VALUE_1ms     65536-3072    // 3072*12/36.864 = 1 mS
#endif
#ifdef  RCOSC_100000                    // Internal RC = 10MHz
    #define VALUE_10us    65536-8       // 17*12/10.0  = 10uS
    #define VALUE_1ms     65536-830     // 1667*12/10.0 = 1mS
#endif
#ifdef  RCOSC_200000                    // Internal RC = 20MHz
    #define VALUE_10us    65536-17      // 17*12/20.0  = 10uS
    #define VALUE_1ms     65536-1667    // 1667*12/20.0 = 1mS
#endif
//-----------------------------------------------------------------------------------------------------------
void Delay1ms(UINT32 u32CNT)
{
    TMOD |= 0x01;                       // Timer0 is 16-bit mode
    TR0 = 1;                            // Trigger Timer0
    while (u32CNT != 0)
    {
        TL0 = LOBYTE(VALUE_1ms);
        TH0 = HIBYTE(VALUE_1ms);
        while (TF0 != 1);               // Check Timer0 Time-Out Flag
        TF0 = 0;
        u32CNT --;
    }
    TR0 = 0;                            // Stop the Timer0
}
