/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2014 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp.
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 27/Jan/2014
//***********************************************************************************************************

//***********************************************************************************************************
//  Application: PWM Function
//  Clock Source from internal RC 20MHz
//***********************************************************************************************************

//=== How to set PWM register ===============================================================================
//  1.set load=1;PWMRUN=1; ==> PWMCON1=0xC0;
//
//  2.Frequency == Fosc/(PWMP+1)
//    Use internal OSC :Fosc = 6MHz
//
//  3.Duty = (PWMP-PWMn+1)/PWMP
//
//  4.PWMP > PWMn ==> Output = High
//===========================================================================================================
/*
//-------- <<< Use Configuration Wizard in Context Menu >>> -------------------------------------------------
//       <o0.0..15> PWM Period<1-4096> <#-1>
//       <o1.0..15> PWM Duty<1-4096> <#-1>
//-------- <<< end of configuration section >>> -------------------------------------------------------------
*/

#define PWMP       0x0FFF;
#define PWM0_Duty  0x0031;

#include <stdio.h>
#include "W79E8213.h"
#include "Typedef.h"
#include "Define.h"

//-----------------------------------------------------------------------------------------------------------
void Init_PWM(void)
{
    UINT16 PWM_shadow;

    PWM_shadow = PWMP;
    PWMPH = HIBYTE(PWM_shadow);         // PWM Period
    PWMPL = LOBYTE(PWM_shadow);

    PWM_shadow = PWM0_Duty;
    PWM0H = HIBYTE(PWM_shadow);         // PWM Duty
    PWM0L = LOBYTE(PWM_shadow);

    PWMCON1 = 0xC0;                     // Enable PWM, auto reload mode
}
//-----------------------------------------------------------------------------------------------------------
void main(void)
{
    Init_PWM();
    while(1);
}