/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2014 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technology Corp.
//  E-Mail: MicroC-8bit@nuvoton.com
//  Date: 27/Jan/2014
//***********************************************************************************************************

//***********************************************************************************************************
//  Application: Power Down Mode
//  Clock Source from internal RC 20MHz
//***********************************************************************************************************

#include <stdio.h>
#include "W79E8213.h"
#include "Typedef.h"
#include "Define.h"

#define Power_Down      0x02
#define Enalbed         0x01

bit Test_Bit = 0;

//-----------------------------------------------------------------------------------------------------------
void INT1_ISR() interrupt 2 using 0 // INT1 interrupt service routine
{
    UINT32 u32delayCount = 10000;
    Test_Bit = ~Test_Bit;
    while(u32delayCount--);
}
//-----------------------------------------------------------------------------------------------------------
void main()
{
    IT1    = 0;                     // INT1 low level triggered
    EX1    = Enalbed ;              // INT1 interrupt open
    EA     = Enalbed ;              // Enable interrupt

    AUXR1 &= 0x00;
    AUXR1 |= 0x40;                  // Disable Brownout Detect function and save power.

    P0     = 0x00;                  // Set pin out as low level(0)
    P1     = 0x10;                  // P1.4(INT1) out as high level(1)
    P2     = 0x00;                  // Using P1.4(INT1) to wake up MCU in power down mode.
    while(1)
    {
        if(Test_Bit)
        {
            PCON |= Power_Down;     // The CPU goes into the power down mode
        }
    }
}
